import 'package:xanno/src/anno/utils/base.dart';

class GFormatter extends GBase {
  final bool enable;

  ///dart文件最大代码行数，包含空行
  ///超过文件将会被统计输出,忽略自动生成的文件
  final int maxLine;

  ///忽略文件列表
  ///不会统计 > 300行优化和代码格式化，但会全局代码统计
  ///从lib目录以下开始配置
  final List<String> ignoresFiles;

  ///忽略被统计的文件夹列表
  ///不会统计 > 300行优化和代码格式化，但会全局代码统计
  ///从lib目录以下开始配置
  final List<String> ignoresDirs;

  ///统计主工程lib下所有源代码行数
  final bool showTotalCodeLines;

  ///去除空行统计所有行和showTotalCodeLines搭配使用
  final bool removeEmptyLines;

  ///全局安装dart_style
  ///pub global activate dart_style
  const GFormatter({
    this.maxLine = 300,
    this.enable = true,
    this.ignoresFiles = const [],
    this.ignoresDirs = const [],
    this.showTotalCodeLines = false,
    this.removeEmptyLines = false,
  }) : super();
}
