String clazzTpl({package}) => """
import 'package:flutter/material.dart';
import 'package:$package/utils/toast_util.dart';
import 'package:$package/utils/print_util.dart';
import 'package:$package/utils/screen_util.dart';
import 'package:$package/widget/base_store_container.dart';
export 'package:$package/store/app_state.dart';
export 'package:$package/generated/l10n.dart';
export 'package:$package/route/main.route.dart';
export 'package:$package/store/theme/theme_state.dart';

mixin BaseStatefulMixin<T extends StatefulWidget> on State<T> {
  void showMsg(String msg) => Toast.show(msg);

  @mustCallSuper
  @override
  void initState() {
    logDebugPrint('\${this.runtimeType.toString()} initState');
    super.initState();
  }

  @mustCallSuper
  @override
  void didUpdateWidget(covariant oldWidget) {
    logDebugPrint('\${this.runtimeType.toString()} didUpdateWidget');
    super.didUpdateWidget(oldWidget);
  }

  @mustCallSuper
  @override
  void reassemble() {
    logDebugPrint('\${this.runtimeType.toString()} reassemble');
    super.reassemble();
  }

  @mustCallSuper
  @override
  void setState(fn) {
    logDebugPrint('\${this.runtimeType.toString()} setState');
    super.setState(fn);
  }

  @mustCallSuper
  @override
  void deactivate() {
    logDebugPrint('\${this.runtimeType.toString()} deactivate');
    super.deactivate();
  }

  @mustCallSuper
  @override
  void dispose() {
    logDebugPrint('\${this.runtimeType.toString()} dispose');
    super.dispose();
  }

  @mustCallSuper
  @override
  void didChangeDependencies() {
    logDebugPrint('\${this.runtimeType.toString()} didChangeDependencies');
    super.didChangeDependencies();
  }

  @mustCallSuper
  @override
  Widget build(BuildContext context) {
    logDebugPrint('\${this.runtimeType.toString()} build');
    return Container();
  }
}

mixin BaseStatelessMixin<T extends StatelessWidget> on StatelessWidget {
  void showMsg(String msg) => Toast.show(msg);

  Widget builder(BuildContext context, ThemeState theme, ReduxState state,
          dynamic dispatch) =>
      Container();

  @mustCallSuper
  @override
  Widget build(BuildContext context) {
    logDebugPrint('\${this.runtimeType.toString()} build');
    return BaseStoreContainer(
        builder: (context, theme, state, dispatch) =>
            builder(context, theme, state, dispatch));
  }
}

AppBar _appBar(ThemeState theme, String title,
    {void Function()? leftPress, void Function()? rightPress}) {
  return AppBar(
    systemOverlayStyle: theme.systemOverlayStyle,
    backgroundColor: theme.body,
    leading: IconButton(
      onPressed: leftPress,
      icon: Icon(Icons.arrow_back_ios, color: theme.title, size: 30),
    ),
    title: Text(
      title,
      style: TextStyle(
        fontSize: 36.sp,
        // fontWeight: FontWeight.bold,
        color: theme.title,
      ),
    ),
    actions: [
      IconButton(
        onPressed: rightPress,
        icon: Icon(Icons.wb_incandescent, color: theme.title, size: 30),
      )
    ],
  );
}
""";
