String clazzTpl({package}) => """
// ignore_for_file: deprecated_member_use_from_same_package
import 'package:$package/debug/app_debug_model.dart';
import 'package:$package/store/app_config/app_config_state.dart';
import 'package:$package/store/theme/theme_state.dart';
import 'package:redux/redux.dart';
import 'package:flutter/material.dart';
import 'package:flutter_redux/flutter_redux.dart';
import 'package:$package/store/redux/redux_state.dart';
export 'package:$package/store/theme/theme_state.dart';
export 'package:redux/redux.dart';
export 'package:flutter_redux/flutter_redux.dart';
export 'package:$package/store/redux/redux_state.dart';

class BaseStoreContainer extends StatelessWidget {
  final void Function(Store<ReduxState>)? onInit;
  final void Function(Store<ReduxState>)? onInitialBuild;
  final void Function(Store<ReduxState>? old, Store<ReduxState> now)?
      onWillChange;
  final void Function(Store<ReduxState>? old, Store<ReduxState> now)?
      onDidChange;
  final void Function(Store<ReduxState>)? onDispose;
  final bool Function(ReduxState)? ignoreChange;
  @Deprecated(
    'Use "builder" instead'
    '使用 builder 替代',
  )
  final Widget Function(BuildContext, Store<ReduxState>)? xbuilder;
  final Widget Function(BuildContext context, ThemeState theme,
      ReduxState state, dynamic dispatch)? builder;
  final bool distinct;
  final bool rebuildOnChange;

  BaseStoreContainer({
    Key? key,
    this.onInit,
    this.onInitialBuild,
    this.onWillChange,
    this.onDidChange,
    this.onDispose,
    this.ignoreChange,
    this.distinct = false,
    this.rebuildOnChange = true,
    this.xbuilder,
    this.builder,
  }) : super(key: key) {
    assert(!(xbuilder == null && builder == null));
  }

  @override
  Widget build(BuildContext context) {
    return StoreConnector<ReduxState, Store<ReduxState>>(
      onInit: (store) {
        StaticStore.store = store;
        if (onInit != null) onInit!(store);
      },
      distinct: distinct,
      onWillChange: onWillChange,
      onDidChange: onDidChange,
      onInitialBuild: onInitialBuild,
      onDispose: onDispose,
      rebuildOnChange: rebuildOnChange,
      ignoreChange: ignoreChange,
      converter: (store) => store,
      builder: (context, store) {
        if (xbuilder != null) {
          return xbuilder!(context, store);
        } else {
          return builder!(
              context, store.state.themeState!, store.state, store.dispatch);
        }
      },
    );
  }
}

class StaticStore {
  static Store<ReduxState>? store;
}

extension BuildContextEx on BuildContext {
  bool get isDev =>
      StaticStore.store!.state.appConfigState!.findAppDebug(AppDebugKey.dev);

  bool isOn(AppDebugKey key) =>
      StaticStore.store!.state.appConfigState!.findAppDebug(key);

  ThemeState get theme => StaticStore.store!.state.themeState!;

  ReduxState get state => StaticStore.store!.state;

  dynamic get dispatch => StaticStore.store!.dispatch;

  String get host => StaticStore.store!.state.appConfigState!.findAppHost();

  Map<String, dynamic> get appInfo {
    final Map<String, dynamic> headers = Map<String, dynamic>();

    /// 平台信息
    headers['device_id'] = AppAndDevice.deviceId;
    headers['device_type'] = AppAndDevice.deviceType;
    headers['device_version'] = AppAndDevice.deviceVersion;

    ///app信息
    headers['app_version'] = AppAndDevice.appVersion;
    headers['app_buildNumber'] = AppAndDevice.appBuildNumber;
    return headers;
  }
}
""";
